=== debian/changelog ===
suitesparse (1:7.3.1+dfsg-2deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:19:33 +0800

suitesparse (1:7.3.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 17 Nov 2023 08:05:29 +0100

suitesparse (1:7.3.1+dfsg-1) experimental; urgency=medium

  * New upstream version 7.3.1+dfsg
  * d/copyright: reflect upstream changes
  * SOVERSION bump of libcholmod (4 → 5)
  * d/rules: add workaround for missing clean rules in upstream build system

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 05 Nov 2023 15:16:39 +0100

suitesparse (1:7.2.2+dfsg-1) unstable; urgency=medium

  * New upstream version 7.2.2+dfsg

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 27 Oct 2023 17:12:23 +0200

suitesparse (1:7.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 7.2.1+dfsg
  * d/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 18 Oct 2023 15:58:43 +0200

suitesparse (1:7.2.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Sep 2023 22:14:59 +0200

suitesparse (1:7.2.0+dfsg-1) experimental; urgency=medium

  * New upstream version 7.2.0+dfsg
  * d/copyright: reflect upstream changes
  * spqr-32bit.patch: drop patch, applied upstream
  * SOVERSION bump of libspqr (3 → 4)
  * Ship new pkg-config files
  * CUDA libraries are no longer being built by upstream build system
    (Closes: #1050503)

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 20 Sep 2023 21:15:27 +0200
